diff -r 1b0b563a81e6 mcabber/mcabber/screen.c
--- a/mcabber/mcabber/screen.c	Wed Mar 13 16:11:16 2013 +0200
+++ b/mcabber/mcabber/screen.c	Wed May 15 12:48:30 2013 +0300
@@ -3630,7 +3630,7 @@
 {
   scr_check_auto_away(TRUE);
   last_activity_buddy = current_buddy;
-  if (process_line(inputLine))
+  if (process_line(inputLine) == cmd_result_quit)
     return 255;
   // Add line to history
   scr_cmdhisto_addline(inputLine);
@@ -3802,8 +3802,12 @@
 void readline_send_multiline(void)
 {
   // Validate current multi-line
-  if (multimode)
-    process_command(mkcmdstr("msay send"), TRUE);
+  if (multimode) {
+    // FIXME - do it without parsing
+    gchar *cmdline = g_strdup("msay send");
+    cmd_execute(cmdline, cmdexe_default);
+    g_free(cmdline);
+  }
 }
 
 void readline_insert(const char *toinsert)
@@ -3883,6 +3887,8 @@
 // Initiate or continue a completion...
 static void scr_handle_tab(void)
 {
+// FIXME completion
+#if 0
   int nrow;
   const char *row;
   const char *cchar;
@@ -3978,6 +3984,7 @@
     if (cchar)
       scr_insert_text(cchar);
   }
+#endif
 }
 
 static void scr_cancel_current_completion(void)
@@ -4098,7 +4105,9 @@
 {
   if (!Curses) return;
   // Leave multi-line mode
-  process_command(mkcmdstr("msay abort"), TRUE);
+  gchar *cmdline = g_strdup("msay abort");
+  cmd_execute(cmdline, cmdexe_default);
+  g_free(cmdline);
   // Same as Ctrl-g, now
   scr_cancel_current_completion();
   scr_end_current_completion();
@@ -4302,10 +4311,12 @@
   boundcmd = settings_get(SETTINGS_TYPE_BINDING, asciikey);
 
   if (boundcmd) {
-    gchar *cmdline = from_utf8(boundcmd);
+    gchar *cmdline = g_strdup(boundcmd);
     scr_check_auto_away(TRUE);
-    if (process_command(cmdline, TRUE))
+    if (cmd_execute(cmdline, cmdexe_default) == cmd_result_quit) {
+      g_free(cmdline);
       return 255; // Quit
+    }
     g_free(cmdline);
     return 0;
   }
diff -r 1b0b563a81e6 mcabber/mcabber/settings.c
--- a/mcabber/mcabber/settings.c	Wed Mar 13 16:11:16 2013 +0200
+++ b/mcabber/mcabber/settings.c	Wed May 15 12:48:30 2013 +0300
@@ -183,28 +183,12 @@
     if ((*line == '\n') || (*line == '\0') || (*line == '#'))
       continue;
 
-    // If we aren't in runtime (i.e. startup) we'll only accept "safe" commands
-    if (!runtime) {
-      const gchar *cmdend = strchr(line, ' ');
-      gchar *cmdname = NULL;
-      gboolean safe;
-      if (cmdend)
-        cmdname = g_strndup(line, cmdend - line);
-      safe = cmd_is_safe(cmdname ? cmdname : line);
-      g_free(cmdname);
-      if (!safe) {
-        scr_log_print(LPRINT_LOGNORM, "Error in configuration file (l. %d): "
-                      "this command can't be used here", ln);
-        err++;
-        continue;
-      }
-    }
-
-    // Set the leading COMMAND_CHAR to build a command line
-    // and process the command
-    *(--line) = COMMAND_CHAR;
-    if (process_command(line, TRUE) == 255)
+    // FIXME: in-buffer conversion? some glib iochannel stuff?
+    gchar *utf8 = to_utf8(line);
+    if (cmd_execute(utf8, runtime ? cmdexe_default : cmdexe_check_safe)
+        == cmd_result_quit)
       mcabber_set_terminate_ui();
+    g_free(utf8);
   }
   g_free(buf);
   fclose(fp);
diff -r 1b0b563a81e6 mcabber/mcabber/xmpp_iq.c
--- a/mcabber/mcabber/xmpp_iq.c	Wed Mar 13 16:11:16 2013 +0200
+++ b/mcabber/mcabber/xmpp_iq.c	Wed May 15 12:48:30 2013 +0300
@@ -71,20 +71,20 @@
 struct adhoc_status {
   char *name;   // the name used by adhoc
   char *description;
-  char *status; // the string, used by setstus
+  enum imstatus status; // corresponding imstatus value
 };
 // It has to match imstatus of roster.h!
 const struct adhoc_status adhoc_status_list[] = {
-  {"offline", "Offline", "offline"},
-  {"online", "Online", "avail"},
-  {"chat", "Chat", "free"},
-  {"dnd", "Do not disturb", "dnd"},
-  {"xa", "Extended away", "notavail"},
-  {"away", "Away", "away"},
+  {"offline", "Offline", offline},
+  {"online", "Online", available},
+  {"chat", "Chat", freeforchat},
+  {"dnd", "Do not disturb", dontdisturb},
+  {"xa", "Extended away", notavail},
+  {"away", "Away", away},
 #ifdef WITH_DEPRECATED_STATUS_INVISIBLE
-  {"invisible", "Invisible", "invisible"},
+  {"invisible", "Invisible", invisible},
 #endif
-  {NULL, NULL, NULL},
+  {NULL, NULL, imstatus_size},
 };
 
 static char *generate_session_id(char *prefix)
@@ -289,10 +289,11 @@
       if (value) {
         for (s = adhoc_status_list; !s->name || strcmp(s->name, value); s++);
         if (s->name) {
-          char *status = g_strdup_printf("%s %s", s->status,
-                                         message ? message : "");
-          cmd_setstatus(NULL, status);
-          g_free(status);
+          // It makes sense to reset autoaway before changing the status
+          // (esp. for FIFO or remote commands) or the behaviour could be
+          // unexpected...
+          scr_check_auto_away(TRUE);
+          xmpp_setstatus(s->status, NULL, message ? message : "", FALSE);
           lm_message_node_set_attribute(command, "status", "completed");
           lm_message_node_add_dataform_result(command,
                                               "Status has been changed");
diff -r 1b0b563a81e6 mcabber/modules/beep/beep.c
--- a/mcabber/modules/beep/beep.c	Wed Mar 13 16:11:16 2013 +0200
+++ b/mcabber/modules/beep/beep.c	Wed May 15 12:48:30 2013 +0300
@@ -31,6 +31,7 @@
 
 static void beep_init   (void);
 static void beep_uninit (void);
+static gchar *do_beep (const cmdopts_t *command, cmdarg_value_t *values);
 
 /* Module description */
 module_info_t info_beep = {
@@ -46,9 +47,7 @@
         .next            = NULL,
 };
 
-static guint    beep_cid  = 0;  /* Command completion category id */
-static gpointer beep_cmid = 0;  /* Command id */
-static guint    beep_hid  = 0;  /* Hook handler id */
+static guint beep_hid  = 0;  /* Hook handler id */
 
 /* Event handler */
 static guint beep_hh(const gchar *hookname, hk_arg_t *args, gpointer userdata)
@@ -61,20 +60,42 @@
   return HOOK_HANDLER_RESULT_ALLOW_MORE_HANDLERS;
 }
 
+static const string2enum_t s2e_onoff[] = {
+  { "on",      1  },
+  { "off",     0  },
+  { "enable",  1  },
+  { "disable", 0  },
+  { "1",       1  },
+  { "0",       0  },
+  { "show",    2  },
+  { NULL,      0  },
+};
+
+typedef enum {
+  pos_beep_enable = 0,
+} pos_beep_t;
+
+static cmdopts_t def_beep = {
+  "beep",
+  cmd_default,
+  NULL,
+  do_beep,
+  NULL,
+  (cmdarg_t[2]){
+    {"on|off", pos_beep_enable, cmdarg_chreq, "show", &cmdarg_type_string2enum, (gpointer)s2e_onoff},
+    {NULL}
+  },
+  NULL
+};
+
 /* beep command handler */
-static void do_beep(char *args)
+static gchar *do_beep(const cmdopts_t *command, cmdarg_value_t *values)
 {
   /* Check arguments, and if recognized,
    * set mcabber option accordingly */
-  if (!strcmp(args, "enable") ||
-      !strcmp(args, "on") ||
-      !strcmp(args, "yes") ||
-      !strcmp(args, "1"))
+  if (values[pos_beep_enable].value.uint == 1)
     settings_set(SETTINGS_TYPE_OPTION, "beep_enable", "1");
-  else if (!strcmp(args, "disable") ||
-           !strcmp(args, "off") ||
-           !strcmp(args, "no") ||
-           !strcmp(args, "0"))
+  else if (values[pos_beep_enable].value.uint == 0)
     settings_set(SETTINGS_TYPE_OPTION, "beep_enable", "0");
 
   /* Output current state, either if state is
@@ -83,19 +104,14 @@
     scr_log_print(LPRINT_NORMAL, "Beep on messages is enabled");
   else
     scr_log_print(LPRINT_NORMAL, "Beep on messages is disabled");
+  return NULL;
 }
 
 /* Initialization */
 static void beep_init(void)
 {
-  /* Create completions */
-  beep_cid = compl_new_category(COMPL_FLAGS_SORT);
-  if (beep_cid) {
-    compl_add_category_word(beep_cid, "enable");
-    compl_add_category_word(beep_cid, "disable");
-  }
   /* Add command */
-  beep_cmid = cmd_add("beep", "", beep_cid, 0, do_beep, NULL);
+  cmd_define(&def_beep);
   /* Add handler
    * We are only interested in incoming message events
    */
@@ -109,11 +125,7 @@
   /* Unregister event handler */
   hk_del_handler(HOOK_POST_MESSAGE_IN, beep_hid);
   /* Unregister command */
-  cmd_del(beep_cmid);
-  /* Give back completion handle */
-  if (beep_cid)
-    compl_del_category(beep_cid);
+  cmd_undef(&def_beep);
 }
 
-/* The End */
 /* vim: set et cindent cinoptions=>2\:2(0 ts=2 sw=2:  For Vim users... */
